﻿Imports System.IO
Imports System.Net
Imports System.Text.RegularExpressions
Imports FtpRequest.FtpItemDts
Imports System.Globalization

Public Class Form1

   Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      FolderBrowser.SelectedPath = Path.GetFullPath("..\..\DataDownloads")
      lbDownloadDestination.Text = FolderBrowser.SelectedPath
   End Sub

   Private Sub Button_Click(ByVal sender As Object, ByVal e As EventArgs) _
         Handles btDownloadDestination.Click, btGetDetails.Click, btFolderUp.Click
      Select Case True
         Case sender Is btDownloadDestination
            With FolderBrowser
               If .ShowDialog <> Windows.Forms.DialogResult.OK Then Return
               lbDownloadDestination.Text = FolderBrowser.SelectedPath
            End With
         Case sender Is btGetDetails
            ListDirectoryDetails(txtFtpSource.Text)
         Case sender Is btFolderUp
            With txtFtpSource.Text
               ListDirectoryDetails(.Substring(0, .LastIndexOf("/"c)))
            End With
      End Select
      System.Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub FtpItemDataGridView_CellContentClick(ByVal sender As Object, ByVal e As DataGridViewCellEventArgs) _
         Handles FtpItemDataGridView.CellContentClick
      Dim rwFtpItm = DirectCast(DirectCast(FtpItemBindingSource.Current, DataRowView).Row, FtpItemRow)
      Select Case e.ColumnIndex
         Case clmBtGetDetails.Index
            ListDirectoryDetails(txtFtpSource.Text & "/" & rwFtpItm.Name)
         Case clmBtDownload.Index
            DownLoadItem(rwFtpItm.Name)
      End Select
      System.Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub ListDirectoryDetails(ByVal url As String)
      txtFtpSource.Text = url
      Dim request = WebRequest.Create(url)
      If ckCredentials.Checked Then request.Credentials = New NetworkCredential(txtUser.Text, txtPassword.Text)
      request.Method = WebRequestMethods.Ftp.ListDirectoryDetails
      Log("List """, request.RequestUri, """")
      FtpItemDts.FtpItem.Clear()
      Using resp = request.GetResponse(), sr = New StreamReader(resp.GetResponseStream)
         While Not sr.EndOfStream
            Dim line = sr.ReadLine
            Console.WriteLine(line)
            ParseLine(line)
         End While
      End Using
   End Sub

   Private _RgxWordAndSpaces As New Regex(".+? +") 'finde viele Buchstaben, gefolgt von vielen Spaces

   Private Sub ParseLine(ByVal line As String)
      'line mag so aussehen: "-rw-r--r--   1 700      101         17145 Sep 13  2000 README.txt"
      'das sind 9 spalten, von denen _RgxWordAndSpaces die ersten 8 spalten sicher matcht
      'Bedeutung der columns: Attributes, k.A., k.A., k.A., Size (ungültig bei Directories), Monat, Tag, Jahr, fileName
      Dim cols As MatchCollection = _RgxWordAndSpaces.Matches(line)
      Dim attrs = cols(0).Value '(Attributes, zb. "-rw-r--r--")
      Dim size = -1 'default Wert -1: ungültige size
      'size befindet sich in cols(4) (zb. "17145")
      'wird nur dann als size ausgewertet, wenn attrs(0) ein '-' ist (sonst ungültig)
      If attrs(0) = "-"c Then size = Integer.Parse(cols(4).Value)
      'Datum setzt sich zusammen aus den matches #5-#7 (zb. "Sep 13  2000 ")
      Dim datum = DateTime.Parse(cols(5).Value & cols(6).Value & cols(7).Value, CultureInfo.InvariantCulture)
      'fileName liegt hinter der 8. column (zb. "README.txt")
      Dim fileName = line.Substring(cols(7).Index + cols(7).Length).Trim
      'jetzt sind alle daten zusammen, um eine FtpItemRow zu adden (die bedeutung der spalten #1-#3 kennichnich)
      FtpItemDts.FtpItem.AddFtpItemRow(attrs, cols(1).Value, cols(2).Value, cols(3).Value, size, datum, fileName, Nothing)
   End Sub

   Private Sub DownLoadItem(ByVal fileName As String)
      Dim request = WebRequest.Create(txtFtpSource.Text & "/"c & fileName)
      If ckCredentials.Checked Then request.Credentials = New NetworkCredential(txtUser.Text, txtPassword.Text)
      request.Method = WebRequestMethods.Ftp.DownloadFile
      Dim dest = Path.Combine(lbDownloadDestination.Text, fileName)
      Log("Download """, request.RequestUri, """ -> """, dest, """")
      Using resp = request.GetResponse(), strmResp = resp.GetResponseStream, _
            strmFile = New FileStream(dest, FileMode.Create)
         Dim buf(1023) As Byte
         Do
            Dim read = strmResp.Read(buf, 0, buf.Length)
            If read = 0 Then Exit Do 'end of Transmission
            strmFile.Write(buf, 0, read)
         Loop
      End Using
   End Sub

   Private Sub Log(ByVal ParamArray args() As Object)
      Dim s = String.Concat(args) & Environment.NewLine
      Console.Write(s)
      txtLog.AppendText(s)
   End Sub

End Class

